from abc import ABC, abstractmethod
from obspython import *

class Service(ABC):

    queue = None

    def set_message_queue(self, queue):
        self.queue = queue

    @abstractmethod
    def knows(self, command):
        pass

    @abstractmethod
    def eval(self, command, response, user):
        pass

    @abstractmethod
    def list_commands(self):
        pass

    def start(self):
        pass

    def stop(self):
        pass

    # OBS subset -----

    def load(self, settings):
        pass

    def create_properties(self):
        props = obs_properties_create()
        return props

    def update(self, settings):
        pass

    def save(self, settings):
        pass
